import { ShContextService } from './sh-context-service';
import { ViewContainerRef, ComponentFactoryResolver, ComponentRef, EventEmitter } from "@angular/core";
import { ShContextOverlayComponent } from './sh-context-overlay.component';
import { ShContextMenuComponent } from "./sh-context-menu.component";
import { InjectionService } from "./injector.service";
import { BeforeMenuEvent, IShContextMenuItem, IShContextOptions } from "./sh-context-menu.models";
export declare class ShContextMenuDirective {
    private viewRef;
    private resolver;
    private ctxService;
    private injectionService;
    menuItems: IShContextMenuItem[];
    dataContext: any;
    options: IShContextOptions;
    onBeforeMenuOpen: EventEmitter<BeforeMenuEvent>;
    ctxComponent: ComponentRef<ShContextMenuComponent>;
    overlayComponent: ComponentRef<ShContextOverlayComponent>;
    constructor(viewRef: ViewContainerRef, resolver: ComponentFactoryResolver, ctxService: ShContextService, injectionService: InjectionService);
    onClick(event: MouseEvent): boolean;
    private createMenu(event, items?);
    registerEvents(): void;
    registerBindings(menuItems: IShContextMenuItem[]): void;
    createContextComponent(): ComponentRef<ShContextMenuComponent>;
    createOverlayComponent(): ComponentRef<ShContextOverlayComponent>;
    setLocation(event: MouseEvent): void;
    closeMenu(): void;
}
